===== arch/ppc/kernel/misc.S 1.64 vs edited =====
--- 1.64/arch/ppc/kernel/misc.S	Mon Sep  8 18:06:59 2003
+++ edited/arch/ppc/kernel/misc.S	Tue Sep  9 22:40:50 2003
@@ -793,13 +793,16 @@
 11:	dcbt	r11,r4
 	addi	r11,r11,L1_CACHE_LINE_SIZE
 	bdnz	11b
-#else /* MAX_L1_COPY_PREFETCH == 1 */
+#else /* MAX_COPY_PREFETCH == 1 */
 	dcbt	r5,r4
 	li	r11,L1_CACHE_LINE_SIZE+4
-#endif /* MAX_L1_COPY_PREFETCH */
+#endif /* MAX_COPY_PREFETCH */
+	li	r10,2
+	li	r0,4096/L1_CACHE_LINE_SIZE - MAX_COPY_PREFETCH
+#else /* CONFIG_8xx */
+    	li	r0,4096/L1_CACHE_LINE_SIZE
 #endif /* CONFIG_8xx */
-
-	li	r0,4096/L1_CACHE_LINE_SIZE
+	
 	mtctr	r0
 1:
 #ifndef CONFIG_8xx
@@ -821,7 +824,17 @@
 #endif
 #endif
 	bdnz	1b
+
+#ifndef CONFIG_8xx	
+	addic.	r10,r10,-1
+	beqlr
+	li	r0,MAX_COPY_PREFETCH
+	li	r11,4
+	mtctr	r0
+	b	1b
+#else	/* CONFIG_8xx */
 	blr
+#endif	
 
 /*
  * void atomic_clear_mask(atomic_t mask, atomic_t *addr)
===== arch/ppc/lib/string.S 1.9 vs edited =====
--- 1.9/arch/ppc/lib/string.S	Sun Aug  3 21:54:48 2003
+++ edited/arch/ppc/lib/string.S	Tue Sep  9 22:41:58 2003
@@ -443,26 +443,36 @@
 
 #if !defined(CONFIG_8xx)
 	/* Here we decide how far ahead to prefetch the source */
+	li	r3,4
 #if MAX_COPY_PREFETCH > 1
 	/* Heuristically, for large transfers we prefetch
 	   MAX_COPY_PREFETCH cachelines ahead.  For small transfers
 	   we prefetch 1 cacheline ahead. */
 	cmpwi	r0,MAX_COPY_PREFETCH
-	li	r7,1
-	li	r3,4
-	ble	111f
+	ble	112f
 	li	r7,MAX_COPY_PREFETCH
-111:	mtctr	r7
-112:	dcbt	r3,r4
+	mtctr	r7
+111:	dcbt	r3,r4
+	addi	r3,r3,CACHELINE_BYTES
+	bdnz	111b
+	b	114f
+#endif /* MAX_COPY_PREFETCH > 1 */
+112:	cmpwi	r0,1
+	beq	113f
 	addi	r3,r3,CACHELINE_BYTES
-	bdnz	112b
-#else /* MAX_COPY_PREFETCH == 1 */
-	li	r3,CACHELINE_BYTES + 4
 	dcbt	r11,r4
-#endif /* MAX_COPY_PREFETCH */
-#endif /* CONFIG_8xx */
-
+	li	r7,1
+	b	114f
+113:	
+	li	r7,0
+114:
+	subf	r0,r7,r0
 	mtctr	r0
+	mr	r0,r7		
+#else /* CONFIG_8xx */
+	mtctr	r0
+#endif /* CONFIG_8xx */
+	
 53:
 #if !defined(CONFIG_8xx)
 	dcbt	r3,r4
@@ -495,6 +505,14 @@
 #endif
 #endif
 	bdnz	53b
+#if !defined(CONFIG_8xx)
+	cmpwi	r0,0
+	beq	63f
+	mtctr	r0
+	li	r3,4
+	li	r0,0
+	b	53b	
+#endif /* CONFIG_8xx */	
 
 63:	srwi.	r0,r5,2
 	mtctr	r0
